
import java.applet.Applet;
import java.awt.BorderLayout;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/**
  * Ejercicio de Java 3D para construir un arbol
  */
public class Ej1 extends Applet 
{
	/**
	  * Crea la rama del cono para el grafo de escena
	  */
	public BranchGroup crearGrafoEscena() 
	{
		// Creamos la rama y la apariencia
		BranchGroup bg = new BranchGroup();
        Appearance apariencia = new Appearance();
        
        // ... Crear el cilindro


		// ... Crear el cono
		
		
		// ... Desplazar el cono

		// ... Colgar el cilindro y el nodo de transformacion del cono de la rama principal

		// Compilar la rama principal        
        bg.compile();

        return bg;
    }

	/**
	  * Constructor. Inicializa el universo y le aade la rama
	  * con el cono
	  */ 
    public Ej1() 
    {
    	setLayout(new BorderLayout());
		Canvas3D canvas3d = new Canvas3D(null);
		add("Center", canvas3d);

        // Crea una escena y la une al universo virtual
        BranchGroup escena = crearGrafoEscena();
        SimpleUniverse simple = new SimpleUniverse(canvas3d);

        // Este comando mueve el ViewPlatform ligeramente hacia
        // atrs para que el objeto pueda ser visualizado
        simple.getViewingPlatform().setNominalViewingTransform();

        simple.addBranchGraph(escena);
    }

    public static void main(String[] args) 
    {
        new MainFrame(new Ej1(), 256, 256);
    }
}
